* this make a new game board for The WALL
; copyright (C) W. Lenerz 2000-2016, see the accompanying licence_txt file.

* v. 1.00	2000 Jun 25 16:54:26


	section new_game
	include dev1_asm_wall_includes
	include dev1_asm_incl_keys_wman_wwork

	xdef	new_game

	xref	random
	XREF	sp4_indic1		; sprites
	XREF	sp4_indic3
	XREF	sp4_indic5

 


; this sets up the data for a new game
ngregs	reg	d0/d4-d7/a2/a3
new_game
	movem.l ngregs,-(a7)
	lea	rndnbr(a4),a3
	move.l	moves(a4),a2
	move.l	a2,current(a4)	; this will be the current status
	move.l	#$10004,d7
	add.w	diff(a4),d7	; this depends on difficulty
	move.w	#tottiles-1,d0
	moveq	#0,d5
	moveq	#0,d4
rndloop move.l	d7,d6		; max & mins
	jsr	random		; get rnd nbr
	cmp.b	d6,d5		; same as earlier?
	bne.s	new		; no->...

	cmp.w	#2,d4		; do we already have three of them?
	beq.s	rndloop 	; yes, get another one ! ->...
	addq.w	#1,d4		; show one more of the same
	bra.s	old_ok		; but it still is ok
new	moveq	#0,d4		; show that it is a new one
	move.b	d6,d5		; this was last one
old_ok	move.b	d6,(a2)+
	dbf	d0,rndloop
	move.w	#nbr_cols-1,lastcol(a4) ; this is the last col
	move.l	ww_pinfo(a4),a2 ; pointer to info wdw list
	move.l	wwi_pobl(a2),a2 ; pointer to objects for first info wdw
	moveq	#13,d0		; i want the 14th object
	mulu	#wwo.elen,d0
	add.l	d0,a2		; i'm pointing to this object now
	lea	sprtblk,a3	; pointer to ptr to sprites
	move.w	diff(a4),d0
	lsl.w	#2,d0		; *4, lword
	add.w	d0,a3		; this is the sprite i want...
	add.l	(a3),a3 	; ...now
	move.l	a3,wwo_pobj(a2) ; new sprite for this wdw
	movem.l (a7)+,ngregs
	rts


; my sprite block: pointers to sprites
sprtblk dc.l	sp4_indic1-*
	dc.l	sp4_indic3-*
	dc.l	sp4_indic5-*
 
	end
